client
	var
		key_states[]

	New()
		. = ..()
		var global/keys[]
		if(!keys)
			keys = new

			#ifndef KB_EXCLUDE_ARROWS
			keys.Add("north", "south", "east", "west")
			#endif

			#ifndef KB_EXCLUDE_MODIFIERS
			keys.Add("ctrl", "alt", "shift")
			#endif
			
			#ifndef KB_EXCLUDE_LETTERS
			for(var/n in text2ascii("a") to text2ascii("z"))
				keys += ascii2text(n)
			keys.Add("space", "return")
			#endif

			#ifndef KB_EXCLUDE_NUMBERS
			for(var/n in 0 to 9)
				keys += "[n]"
			#endif

		var macro = "macro"
		for(var/k in keys)
			var encoded = url_encode(lowertext(k))
			winset(src, "kdn_[encoded]", list2params(list(
				parent = macro,
				name = encoded,
				command = ".key-down \"[k]\"")))
			winset(src, "kup_[encoded]", list2params(list(
				parent = macro,
				name = "[encoded]+UP",
				command = ".key-up \"[k]\"")))

	verb
		key_down(key as text)
			set name = ".key down", instant = TRUE
			key = lowertext(key)
			if(!key_states)
				key_states = list("[key]" = TRUE)
				KeyDown(key)
			else
				key_states[key] = TRUE
				KeyDown(key)

		key_up(key as text)
			set name = ".key up", instant = TRUE
			key = lowertext(key)
			if(key_states)
				if(key_states[key])
					key_states -= key
					KeyUp(key)
				if(!key_states.len)
					key_states = null

	proc
		KeyDown(Key)

		KeyUp(Key) 

		IsKeyDown(Key)
			return Key && key_states && (key_states[lowertext(Key)])

		GetAxis(Positive, Negative)
			return IsKeyDown(Positive) - IsKeyDown(Negative)
