var static_vector2/vector2 = new

proc
	vector2(x, y)
		return new /vector2 (x, y)

static_vector2
	proc
		Polar(Magnitude, Angle) 
			return vector2(Magnitude * sin(Angle), Magnitude * cos(Angle))

vector2
	var x, y

	New(X, Y)
		x = X
		y = Y

	proc
		Copy() 
			return new /vector2 (x, y)

		Equals(vector2/V) 
			return x == V.x && y == V.y

		IsParallel(vector2/V)
			return Equals(V) || x == -V.x && y == -V.y

		Add(vector2/V) 
			return new /vector2 (x + V.x, y + V.y)

		Subtract(vector2/V) 
			return new /vector2 (x - V.x, y - V.y)

		Scale(S) 
			return new /vector2 (x * S, y * S)

		Dot(vector2/V) 
			return x * V.x + y * V.y

		Magnitude() 
			return sqrt(Dot(src))

		Angle()
			return (x||y) && (y >= 0 \
				?  arccos(x / sqrt(x*x + y*y)) \
				: -arccos(x / sqrt(x*x + y*y)))

		Unit() 
			return Scale(1/Magnitude())

		ToText() 
			return "([x], [y])"

		Rotate(Angle)
			var c = cos(Angle), s = sin(Angle)
			return new /vector2 (c*x - s*y, s*x + c*y)

		IsZero() 
			return !(x || y)

		CrossZ(vector2/V) 
			return x * V.y - y * V.x

		IsBetween(vector2/A, vector2/C) 
			return A.CrossZ(src)*A.CrossZ(C) >= 0 \
				&& C.CrossZ(src)*C.CrossZ(A) >= 0
